
    

Dim num_cols

Dim game(6)
Dim pile(4)

Dim ACE, HEARTS,DIAMONDS,CLUBS,SPADES

num_cols = 6

ACE      = 1
HEARTS   = &H10
DIAMONDS = &H20
CLUBS    = &H30
SPADES   = &H40

Sub bdeal_Click ()
    deck.NumCards = 52
    
    For i = 0 To 20
        deck.Shuffle
    Next
        
    For i = 0 To num_cols - 1
        game(i).NumCards = 0
        game(i).TopCard = deck.TopCard
    Next

    pick.NumCards = 0
    thrash.NumCards = 0
    
    For i = 0 To 3
        pile(i).NumCards = 0
    Next

End Sub

' line 53

Sub check_win ()
    For i = 0 To 3
        If pile(i).NumCards < 13 Then
            Exit Sub
        End If
    Next

    MsgBox "congratulations, you won!"

End Sub

Sub deck_Click ()
    If pick.NumCards = 0 And deck.NumCards > 0 Then
        pick.TopCard = deck.TopCard
    End If
End Sub

Sub game_Click (index)
    
    If pick.NumCards = 0 Then

        c = game(index).Current
        n = game(index).NumCards
        
        game(index).PackOnRemove = False
        For i = c To n - 1
            pick.TopCard = game(index).RemoveCard(i)
        Next
        game(index).Pack
    
    Else
        If game_valid(index) Then
            game(index).AddCards = pick
            pick.Clear
        End If
    End If

End Sub

Sub game0_Click ()
    game_Click 0
End Sub
Sub game1_Click ()
    game_Click 1
End Sub
Sub game2_Click ()
    game_Click 2
End Sub
Sub game3_Click ()
    game_Click 3
End Sub
Sub game4_Click ()
    game_Click 4
End Sub
Sub game5_Click ()
    game_Click 5
End Sub


Function game_valid (index)
    
    ng = game(index).NumCards
        
    If ng = 0 Then
        game_valid = True
    Else
        game_valid = False
        
        vp = pick.Value(0)
        sp = suit_index((pick.Suit(0)))
        
        vg = game(index).Value(ng - 1)
        sg = suit_index((game(index).Suit(ng - 1)))

        If vp <> vg - 1 Then Exit Function

        If sg = sp Then Exit Function
        If sg < 2 And sp < 2 Then Exit Function
        If sg > 1 And sp > 1 Then Exit Function

        game_valid = True

    End If
    
End Function




Sub pick_pile ()

    If pick.NumCards = 1 Then
        i = suit_index((pick.Suit(0)))
        V = pick.Value(0)

        If V = ACE Then
            pile(i).TopCard = pick.BottomCard
        Else
            If pile(i).NumCards > 0 Then
                vp = pile(i).Value(pile(i).NumCards - 1)
                If vp = V - 1 Then
                    pile(i).TopCard = pick.BottomCard
                End If
            End If
        End If
    End If

End Sub

Sub pile0_Change ()
    check_win
End Sub
Sub pile1_Change ()
    check_win
End Sub
Sub pile2_Change ()
    check_win
End Sub
Sub pile3_Change ()
    check_win
End Sub

Sub pile0_Click ()
    pick_pile
End Sub
Sub pile1_Click ()
    pick_pile
End Sub
Sub pile2_Click ()
    pick_pile
End Sub
Sub pile3_Click ()
    pick_pile
End Sub


Function suit_index (S)

    Select Case S
        Case HEARTS
            i = 0
        Case DIAMONDS
            i = 1
        Case CLUBS
            i = 2
        Case SPADES
            i = 3
        Case Else
            i = -1
    End Select
    suit_index = i

End Function

Sub thrash_Click ()
    If pick.NumCards = 1 Then
        thrash.TopCard = pick.TopCard
    Else
        If thrash.NumCards > 0 And pick.NumCards = 0 Then
            pick.TopCard = thrash.TopCard
        End If
    End If

End Sub

Sub window_onLoad()
bDeal.Name = "bDeal"
bDeal.Value = "Deal"

    Set pile(0) = pile0
    Set pile(1) = pile1
    Set pile(2) = pile2
    Set pile(3) = pile3

    Set game(0) = game0
    Set game(1) = game1
    Set game(2) = game2
    Set game(3) = game3
    Set game(4) = game4
    Set game(5) = game5
    
    bdeal_click
end sub


   
    



Sub bDeal_onClick()
bdeal_click
End Sub
